﻿using UnityEngine;
using System.Collections;

public class ControllerScript : MonoBehaviour {

	public Transform prefabPlayer;
	public Transform prefabBots;
	public GameObject prefabCompteur;
	protected int lives;
	protected bool gameOver = false;
	protected float timerBeforeDeath;
	protected int score;
	protected int currentMultiplier;
	protected int lastIndicator;
	protected float pointTime;
	protected float startTime;
	protected float indicatorTime;
	protected float colorPointTime;
	protected float behaviorStartTime;
	protected float behaviorPlayerStartTime;
	protected float behaviorTime;
	protected int currentBehavior;
	protected float timeBeforeNextcolor;
	protected float timeToPerfect;
	protected float timeToCorrect;
	protected float timeDuringIndicator;
	protected bool needInput;
	protected bool needColor;
	protected int currentColor;
	protected bool outOfRange;
	protected int scoreCoef;
	protected bool furyMode;
	protected int startScore;
	protected int[] paliers = new int[10];
	protected int palierActuel = 0;
	protected bool inPause;
	protected GameObject compteRebours;

	void Start () {
		for (int i = 0; i < 10; i++) {
			paliers [i] = 3000 + i * 3000;
		}
		Instantiate (prefabPlayer, new Vector3 (-3.5f, 4f, 0f), Quaternion.identity);
		lives = 5;
		score = 0;
		currentMultiplier = 1;
		lastIndicator = 0;
		pointTime = 0f;
		timerBeforeDeath = 1f;
		timeDuringIndicator = 0.5f;
		behaviorTime = 3f;
		startTime = Time.time;
		scoreCoef = 10;
		startScore = 0;
		currentColor = 1;
		needColor = false;
		inPause = true;
		compteRebours = (GameObject) Instantiate (prefabCompteur, Vector3.zero, Quaternion.identity);
		compteRebours.GetComponent<Animator> ().SetBool ("inPause", inPause);
	}

	void Update () {
		if (inPause && Time.time - startTime >= 4f) {
			inPause = false;
			Instantiate (prefabBots, new Vector3 (-6f, 3f, 0f), Quaternion.identity);
			compteRebours.GetComponent<Animator> ().SetBool ("inPause", inPause);
			startTime = Time.time;
			playerOutOfRange ();
		}
		if (!inPause && !gameOver) {
			if (outOfRange) {
				if (Time.time - pointTime >= timerBeforeDeath) {
					loseLife ();
					pointTime = Time.time;
				}
			}
			score += scoreCoef * currentMultiplier;
			if (lastIndicator != 0 && lastIndicator != 4 && Time.time - indicatorTime >= timeDuringIndicator) {
				lastIndicator = 0;
				indicatorChanged ();
			}
			if (currentBehavior != 0 && Time.time - behaviorPlayerStartTime >= behaviorTime) {
				GameObject.FindGameObjectWithTag ("Player").GetComponent<Animator> ().SetInteger ("behavior", 0);
				currentBehavior = 0;
			}
			if ((palierActuel < 10) && (score - startScore > paliers [palierActuel])) {
				palierActuel += 1;
				// une pate, un changement de strategie
				if (palierActuel != 0 && palierActuel % 2 == 0) {
					gameObject.GetComponent<Map> ().nextPattern();
				}
				GameObject.Find ("Star").GetComponent<Animator> ().SetInteger ("state", palierActuel);
			}
			if (palierActuel == 10) {
				furyMode = true;
				GameObject.Find ("sceneSong").GetComponent<AudioSource> ().pitch = 1.3f;
				currentMultiplier = 8;
				lastIndicator = 4;
				indicatorChanged ();
				GameObject.Find ("Multiplicateur").GetComponent<Animator> ().SetBool ("fury_mode", furyMode);
				GameObject.Find ("Multiplicateur").GetComponent<Animator> ().SetInteger ("multiplier", currentMultiplier);
			}
			// Check l'appui d'une touche.
			if (needInput == false && needColor == false && Input.anyKeyDown) {
				if (Input.GetKeyDown("space") || Input.GetKeyDown ("joystick button 4")) {
					// Clap dans les mains.
					GameObject.FindGameObjectWithTag ("Player").GetComponent<Animator> ().SetInteger ("behavior", 1);
					currentBehavior = 1;
					behaviorPlayerStartTime = Time.time;
				} else if (Input.GetKeyDown("left shift") || Input.GetKeyDown ("joystick button 5")) {
					// Twist
					GameObject.FindGameObjectWithTag ("Player").GetComponent<Animator> ().SetInteger ("behavior", 2);
					currentBehavior = 2;
					behaviorPlayerStartTime = Time.time;
				}
				//loseLife ();
				GameObject.Find ("Multiplicateur").GetComponent<Animator> ().SetInteger ("multiplier", currentMultiplier);
				return;
			}
			// Attend un input de l'utilisateur.
			/*
			if (needInput || needColor) {
				int botBehavior = GameObject.FindGameObjectWithTag ("Bot").GetComponent<Animator> ().GetInteger ("behavior");
				int behaviorChosen = 0;
				int chosenColor = 0;
				if (Input.GetKeyDown("space") || Input.GetKeyDown("joystick button 4")) {
					GameObject.FindGameObjectWithTag ("Player").GetComponent<Animator> ().SetInteger ("behavior", 1);
					behaviorChosen = 1;
					behaviorPlayerStartTime = Time.time;
				} 
				else if (Input.GetKeyDown("left shift") || Input.GetKeyDown("joystick button 5")){
					// Twist
					GameObject.FindGameObjectWithTag ("Player").GetComponent<Animator> ().SetInteger ("behavior", 2);
					behaviorChosen = 2;
					behaviorPlayerStartTime = Time.time;
				} else if (Input.GetKeyDown("a") || Input.GetKeyDown("joystick button 0")) {
					chosenColor = 1;
				} else if (Input.GetKeyDown("z") || Input.GetKeyDown("joystick button 1")) {
					chosenColor = 2;
				} else if (Input.GetKeyDown("e") || Input.GetKeyDown("joystick button 2")){
					chosenColor = 3;
				} else if (Input.GetKeyDown("r") || Input.GetKeyDown("joystick button 3")){
					chosenColor = 4;
				}
				if(behaviorChosen != 0 && behaviorChosen != botBehavior) {
					loseLife ();
					if (needColor) {
						needColor = false;
					}
					if (needInput) {
						needInput = false;
					}
					GameObject.Find ("Multiplicateur").GetComponent<Animator> ().SetInteger ("multiplier", currentMultiplier);
					return;
				}
				if(chosenColor != currentColor) {
					loseLife ();
					if (needColor) {
						needColor = false;
					}
					if (needInput) {
						needInput = false;
					}
					GameObject.Find ("Multiplicateur").GetComponent<Animator> ().SetInteger ("multiplier", currentMultiplier);
					return;
				}
				if (Time.time - behaviorStartTime > timeToCorrect) {
					loseLife ();
					if (needColor) {
						needColor = false;
					}
					if (needInput) {
						needInput = false;
					}
					GameObject.Find ("Multiplicateur").GetComponent<Animator> ().SetInteger ("multiplier", currentMultiplier);
					return;
				}
				if (Time.time - behaviorStartTime > timeToPerfect) {
					lastIndicator = 2;
					indicatorChanged ();
					if (needColor) {
						needColor = false;
					}
					if (needInput) {
						needInput = false;
					}
					if (!furyMode) {
						currentMultiplier = 2;
					}
					GameObject.Find ("Multiplicateur").GetComponent<Animator> ().SetInteger ("multiplier", currentMultiplier);
					return;
				}
				lastIndicator = 3;
				indicatorChanged ();
				if (needColor) {
					needColor = false;
				}
				if (needInput) {
					needInput = false;
				}
				currentMultiplier = 4;
				GameObject.Find ("Multiplicateur").GetComponent<Animator> ().SetInteger ("multiplier", currentMultiplier);
			}
			*/
		}
	}

	public void behaviorChanged(){
		behaviorStartTime = Time.time;
		needInput = true;
	}

	protected void winLife(){
		if (lives < 5) {
			lives++;
		}
	}

	protected void loseLife(){
		lives--;
		currentMultiplier = 1;
		startScore = score;
		palierActuel = 0;
		GameObject.Find ("Star").GetComponent<Animator> ().SetInteger ("state", palierActuel);
		lastIndicator = 1;
		indicatorChanged ();
		GameObject.Find ("Multiplicateur").GetComponent<Animator> ().SetInteger ("multiplier", currentMultiplier);
		GameObject.Find ("Bulles").GetComponent<Animator> ().SetInteger ("state", lives);
		if (furyMode) {
			furyMode = false;
			GameObject.Find ("sceneSong").GetComponent<AudioSource> ().pitch = 1f;
			GameObject.Find ("Multiplicateur").GetComponent<Animator> ().SetBool ("fury_mode", furyMode);
		}
		if (lives <= 0) {
			gameOver = true;
			saveScore ();
		}
	}

	public void indicatorChanged(){
		indicatorTime = Time.time;
		GameObject.Find ("Indicateur").GetComponent<Animator> ().SetInteger ("state", lastIndicator);
	}

	public bool isGameOver(){
		return gameOver;
	}

	public void playerOutOfRange(){
		outOfRange = true;
		pointTime = Time.time;
		currentMultiplier = 1;
		GameObject.Find ("Multiplicateur").GetComponent<Animator> ().SetInteger ("multiplier", currentMultiplier);
	}

	public void playerInOfRange(){
		outOfRange = false;
	}

	public void setGroundColor(){
		colorPointTime = Time.time;
		timeBeforeNextcolor = Random.Range (2f, 5f);
	}

	protected void saveScore(){
		if (PlayerPrefs.GetInt ("Score") < score) {
			PlayerPrefs.SetInt ("Score", score);
		}
	}
}
