﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class PlayerScript : MonoBehaviour {

	protected float vitesse = 3.2f;

	public List<GameObject> characterList = new List<GameObject>(); 

	public Vector3 startPosition;

	protected Vector3 direction;

	void Start () {
		
		direction = Vector3.zero;

		GameObject[] allCharacters = GameObject.FindGameObjectsWithTag("Bot");

		foreach (GameObject character in allCharacters) {
			characterList.Add(character);
		}

		characterList.Add (this.gameObject);
	}

	void Update(){
		if (!GameObject.Find ("_GM").GetComponent<ControllerScript> ().isGameOver ()) {
			// Mise à jour du déplacement
			direction = new Vector3 (Input.GetAxisRaw ("Horizontal"), Input.GetAxisRaw ("Vertical"), 0);
			transform.Translate (direction * vitesse * Time.deltaTime);

			// Gestion des calques
			if (characterList.Count > 0) {
				characterList.Sort (delegate(GameObject a, GameObject b) {
					return (b.transform.position.y).CompareTo (a.transform.position.y);
				});
			}
			for (int i = 0; i < characterList.Count; i++) {
				if (characterList [i].GetComponent<SpriteRenderer> () != null) {
					characterList [i].GetComponent<SpriteRenderer> ().sortingOrder = i;
				}
			}
		}
	}

	void OnTriggerEnter2D(Collider2D collider){
		if (collider.tag == "Crabes") {
			GameObject.Find ("_GM").GetComponent<ControllerScript> ().playerInOfRange();


			GameObject.Find ("zoneCouleurNO").GetComponent<SpriteRenderer> ().enabled = false;
			GameObject.Find ("zoneCouleurOK").GetComponent<SpriteRenderer> ().enabled = true;
		}
	}

	void OnTriggerExit2D(Collider2D collider){
		if (collider.tag == "Crabes") {
			GameObject.Find ("_GM").GetComponent<ControllerScript> ().playerOutOfRange ();
			GameObject.Find ("zoneCouleurNO").GetComponent<SpriteRenderer> ().enabled = true;
			GameObject.Find ("zoneCouleurOK").GetComponent<SpriteRenderer> ().enabled = false;

		}
	}

}
