﻿using UnityEngine;
using System.Collections;
using UnityEngine.SceneManagement;


public class main_menu : MonoBehaviour {

	public GameObject titre;
	public GameObject logo;

	public GUIStyle styleButtonPlay;
	public GUIStyle styleButtonQuit;
	public GUIStyle texteScore;
	public int topScore;
	public AudioSource clapSound;
	protected int index;
	protected float moveRate = 0.4f;
	protected float nextMove = 0.0f;

	public Transform bull;

	protected bool isClosing;



	void Start () {
		if (!PlayerPrefs.HasKey("Score")) {
			PlayerPrefs.SetInt ("Score", 0);
		}
		topScore = PlayerPrefs.GetInt ("Score");

		//Cursor.lockState = CursorLockMode.Locked;

		isClosing = false;

		index = 0;

		titre.transform.position = new Vector2 (-10f, -5f);

		InvokeRepeating ("spawnBull", 0f, 1f);


	}

	void spawnBull(){
		
		Instantiate (bull, new Vector3 (Random.Range(-7, 7), Random.Range(-10, -7), 0f), Quaternion.identity);
	
	}
	
	void Update () {

		if (!isClosing) {


			if (index==0 && Input.GetKeyDown("joystick button 0")){
				isClosing = true;
				clapSound.Play ();
				StartCoroutine ("loadSceneAfterSound");
			}


			if (index == 1 && Input.GetKeyDown("joystick button 0")){
				clapSound.Play ();
				Application.Quit ();
			}

			if (titre.transform.position.x < 0.2f)
				titre.transform.Translate (Vector3.right * 7.0f * Time.deltaTime);

			if (titre.transform.position.y < 2.8f)
				titre.transform.Translate (Vector3.up * 7.0f * Time.deltaTime);

			if (logo.transform.position.y < -1.4f)
				logo.transform.Translate (Vector3.up * 2.0f * Time.deltaTime);

			if (Input.GetAxisRaw ("Vertical") < 0 && Time.time > nextMove) {
				nextMove = Time.time + moveRate;
				index = (index + 1) % 2;
			}

			if (Input.GetAxisRaw ("Vertical") > 0 && Time.time > nextMove) {
				nextMove = Time.time + moveRate;

				index--;

				if (index == -1)
					index = 1;
				
			}

		} else {

			titre.transform.Translate(Vector3.up * 10.0f * Time.deltaTime);

			logo.transform.Translate (Vector3.down * 15.0f * Time.deltaTime);


		}


	
	}

	IEnumerator loadSceneAfterSound(){
		yield return new WaitForSeconds (0.5f);
		SceneManager.LoadScene ("GameScene");
	}
		

	void OnGUI(){


		GUI.Label (new Rect (new Vector2 (110,420), new Vector2 (280, 100)), topScore.ToString(), texteScore);

		GUI.SetNextControlName("Play");
		if (GUI.Button(new Rect(new Vector2(350,300),new Vector2(280,100)),"",styleButtonPlay)){
			isClosing = true;
			clapSound.Play ();
			StartCoroutine ("loadSceneAfterSound");
		}
			

		GUI.SetNextControlName("Quit");
		if (GUI.Button(new Rect(new Vector2(340,450),new Vector2(300,80)),"",styleButtonQuit)){
			clapSound.Play ();
			Application.Quit ();
		}



		switch (index) {

			case 0:
				GUI.FocusControl ("Play");
				break;


			case 1:
				GUI.FocusControl ("Quit");
				break;

		}

	

	}
}
